diff -u -r linux.clean/drivers/scsi/hosts.h linux.new2/drivers/scsi/hosts.h
--- linux.clean/drivers/scsi/hosts.h	Mon Sep  6 04:50:28 1999
+++ linux.new2/drivers/scsi/hosts.h	Sun Sep  5 15:25:00 1999
@@ -1,6 +1,6 @@
 /*
  *  hosts.h Copyright (C) 1992 Drew Eckhardt
- *          Copyright (C) 1993, 1994, 1995 Eric Youngdale
+ *          Copyright (C) 1993, 1994, 1995, 1998, 1999 Eric Youngdale
  *
  *  mid to low-level SCSI driver interface header
  *      Initial versions: Drew Eckhardt
@@ -8,7 +8,7 @@
  *
  *  <drew@colorado.edu>
  *
- *	 Modified by Eric Youngdale eric@aib.com to
+ *	 Modified by Eric Youngdale eric@andante.org to
  *	 add scatter-gather, multiple outstanding request, and other
  *	 enhancements.
  *
@@ -297,6 +297,8 @@
      */
     struct Scsi_Host      * next;
     Scsi_Device           * host_queue;
+
+#ifndef CONFIG_SCSI_NEW_QUEUES
     /*
      * List of commands that have been rejected because either the host
      * or the device was busy.  These need to be retried relatively quickly,
@@ -304,6 +306,7 @@
      * is available.
      */
     Scsi_Cmnd             * pending_commands;
+#endif
 
     struct task_struct    * ehandler;  /* Error recovery thread. */
     struct semaphore      * eh_wait;   /* The error recovery thread waits on
@@ -336,6 +339,7 @@
     unsigned int max_lun;
     unsigned int max_channel;
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     /*
      * Pointer to a circularly linked list - this indicates the hosts
      * that should be locked out of performing I/O while we have an active
@@ -343,6 +347,7 @@
      */
     struct Scsi_Host * block;
     unsigned wish_block:1;
+#endif
 
     /* These parameters should be set by the detect routine */
     unsigned char *base;
@@ -387,9 +392,16 @@
      * Host uses correct SCSI ordering not PC ordering. The bit is
      * set for the minority of drivers whose authors actually read the spec ;)
      */
-
     unsigned reverse_ordering:1;
-    
+
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    /*
+     * Indicates that one or more devices on this host were starved, and
+     * when the device becomes less busy that we need to feed them.
+     */
+    unsigned some_device_starved:1;
+#endif
+   
     void (*select_queue_depths)(struct Scsi_Host *, Scsi_Device *);
 
     /*
@@ -408,7 +420,6 @@
 
 extern void build_proc_dir_entries(Scsi_Host_Template  *);
 
-
 /*
  *  scsi_init initializes the scsi hosts.
  */
@@ -452,6 +463,9 @@
     void (*finish)(void);	  /* Perform initialization after attachment */
     int (*attach)(Scsi_Device *); /* Attach devices to arrays */
     void (*detach)(Scsi_Device *);
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    int (*init_command)(Scsi_Cmnd *);     /* Used by new queueing code. */
+#endif
 };
 
 extern struct Scsi_Device_Template sd_template;
